common/rc: factor out _scratch_xfs_[get|set]_sb_field
[xfstests-dev.git] / tests / xfs / 098
1 #! /bin/bash
2 # FS QA Test No. 098
3 #
4 # Create and populate an XFS filesystem, corrupt the journal, then see how
5 # the kernel and xfs_repair deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44 . ./common/populate
45
46 # real QA test starts here
47 _supported_fs xfs
48 _supported_os Linux
49
50 _require_scratch
51 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
52 _require_attrs
53 _require_populate_commands
54 _require_xfs_db_blocktrash_z_command
55 test -z "${FUZZ_ARGS}" && FUZZ_ARGS="-n 8 -3"
56
57 rm -f $seqres.full
58
59 # If we corrupt log on a CONFIG_XFS_WARN build, there will be mount related
60 # WARNINGs in dmesg as expected.  We don't want to simply _disable_dmesg_check
61 # which could miss other potential bugs, so filter out the intentional WARNINGs,
62 # make sure test doesn't fail because of this warning and fails on other WARNINGs.
63 filter_xfs_dmesg()
64 {
65         local warn="WARNING:.*fs/xfs/xfs_message\.c:.*asswarn.*"
66         sed -e "s#$warn#Intentional warnings in asswarn#"
67 }
68
69 TESTDIR="${SCRATCH_MNT}/scratchdir"
70 TESTFILE="${TESTDIR}/testfile"
71
72 echo "+ create scratch fs"
73 _scratch_mkfs_xfs > /dev/null
74
75 echo "+ mount fs image"
76 _scratch_mount
77 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
78
79 echo "+ make some files"
80 mkdir -p "${TESTDIR}"
81 for x in `seq 1 1024`; do
82         touch "${SCRATCH_MNT}/junk.${x}"
83         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
84         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
85                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
86                 break
87         fi
88 done
89 for x in `seq 2 64`; do
90         touch "${TESTFILE}.${x}"
91 done
92 inode="$(stat -c '%i' "${TESTFILE}.1")"
93 umount "${SCRATCH_MNT}"
94
95 echo "+ check fs"
96 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
97
98 echo "+ corrupt image"
99 logstart="$(_scratch_xfs_get_sb_field logstart)"
100 logstart="$(_scratch_xfs_db -c "convert fsblock ${logstart} byte" | sed -e 's/^.*(\([0-9]*\).*$/\1/g')"
101 logblocks="$(_scratch_xfs_get_sb_field logblocks)"
102 $XFS_IO_PROG -f -c "pwrite -S 0x62 ${logstart} $((logblocks * blksz))" "${SCRATCH_DEV}" >> $seqres.full
103
104 echo "+ mount image"
105 _scratch_mount 2>/dev/null && _fail "mount should not succeed"
106
107 echo "+ repair fs"
108 _repair_scratch_fs >> $seqres.full 2>&1
109
110 # mount may trigger related WARNINGs, so filter them.
111 _check_dmesg filter_xfs_dmesg
112
113 echo "+ mount image (2)"
114 _scratch_mount
115
116 echo "+ chattr -R -i"
117 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
118
119 echo "+ modify files (2)"
120 broken=0
121 for x in `seq 1 64`; do
122         test -e "${TESTFILE}.${x}" || continue
123         echo moo | dd oflag=append conv=notrunc of="${TESTFILE}.${x}" 2>/dev/null
124         test $? -ne 0 && broken=1
125 done
126 echo "broken: ${broken}"
127 umount "${SCRATCH_MNT}"
128
129 echo "+ check fs (2)"
130 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
131
132 status=0
133 exit